Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bugzilla DB migration completed. Please report issues to Infra team via email via infra@gentoo.org or IRC
Bug 375835 - Enhance BinpkgFetcher to support SELinux
Summary: Enhance BinpkgFetcher to support SELinux
Status: RESOLVED FIXED
Alias: None
Product: Portage Development
Classification: Unclassified
Component: Enhancement/Feature Requests (show other bugs)
Hardware: All Linux
: Normal enhancement (vote)
Assignee: Portage team
URL:
Whiteboard:
Keywords: InVCS
Depends on:
Blocks: 373933
  Show dependency tree
 
Reported: 2011-07-21 07:44 UTC by Sven Vermeulen
Modified: 2011-07-29 20:01 UTC (History)
1 user (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
Support transition to portage_fetch_t (BinpkgFetcher.patch,1014 bytes, patch)
2011-07-21 08:22 UTC, Sven Vermeulen
Details | Diff
support selinux PORTAGE_FETCH_T in BinpkgFetcher (binpkg_selinux.patch,2.06 KB, patch)
2011-07-21 17:06 UTC, Zac Medico
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Sven Vermeulen 2011-07-21 07:44:08 UTC
Portage supports SELinux integration in various locations / hooks throughout the code. One of the hooks is within fetch.py where the fetching of data (through wget) calls the selinux-specific code to transition to PORTAGE_FETCH_T.

For SELinux, we need the same to happen within the BinpkgFetcher.py since there, Portage also fetches data from remote locations (and as such requires PORTAGE_FETCH_T).

Reproducible: Always




Portage 2.1.10.3 (hardened/linux/amd64/selinux, gcc-4.4.5, glibc-2.12.2-r0, 2.6.38-hardened-r6 x86_64)
=================================================================
System uname: Linux-2.6.38-hardened-r6-x86_64-Intel-R-_Core-TM-_i5_CPU_M_430_@_2.27GHz-with-gentoo-2.0.2
Timestamp of tree: Sun, 17 Jul 2011 15:30:01 +0000
app-shells/bash:          4.1_p9
dev-java/java-config:     2.1.11-r3
dev-lang/python:          2.6.6-r2, 2.7.1-r1, 3.1.3-r1
dev-util/cmake:           2.8.4-r1
dev-util/pkgconfig:       0.26
sys-apps/baselayout:      2.0.2
sys-apps/openrc:          0.8.3-r1
sys-apps/sandbox:         2.4
sys-devel/autoconf:       2.13, 2.68
sys-devel/automake:       1.10.3, 1.11.1
sys-devel/binutils:       2.20.1-r1
sys-devel/gcc:            4.4.5
sys-devel/gcc-config:     1.4.1-r1
sys-devel/libtool:        2.2.10
sys-devel/make:           3.82
sys-kernel/linux-headers: 2.6.36.1 (virtual/os-headers)
sys-libs/glibc:           2.12.2
Repositories: gentoo sjvermeu hardened-dev
ACCEPT_KEYWORDS="amd64"
ACCEPT_LICENSE="* -@EULA Broadcom skype-eula AdobeFlash-10.1"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-march=core2 -O2 -pipe"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/share/config /usr/share/gnupg/qualified.txt /var/lib/hsqldb"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/env.d /etc/env.d/java/ /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo /etc/texmf/language.dat.d /etc/texmf/language.def.d /etc/texmf/updmap.d /etc/texmf/web2c"
CXXFLAGS="-march=core2 -O2 -pipe"
DISTDIR="/usr/portage/distfiles"
FEATURES="assume-digests binpkg-logs distlocks ebuild-locks fixlafiles fixpackages news parallel-fetch protect-owned sandbox selinux sesandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch"
FFLAGS=""
GENTOO_MIRRORS="http://distfiles.gentoo.org"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
LINGUAS="en nl fr"
MAKEOPTS="-j4"
PKGDIR="/usr/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --compress --force --whole-file --delete --stats --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/usr/portage"
PORTDIR_OVERLAY="/home/swift/Development/Centralized/gentoo.overlay /home/swift/Development/Centralized/hardened-dev"
SYNC="rsync://rsync.gentoo.org/gentoo-portage"
USE="X amd64 apng berkdb bzip2 cairo cli cracklib crypt cups cxx dbus device-mapper dri dvd dynamic gdbm gnutls gpg graphviz gtk hardened iconv imap jpeg justify mmx modules mp3 mudflap multilib ncurses nls nptl nptlonly nsplugin ogg open_perms openmp pam pcre perl png policykit pppd python qemu qt3support readline sasl selinux session smime smtp sse sse2 ssl sysfs tcpd ubac udev unicode urandom v4l2 vde vorbis xorg xv zlib" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" ALSA_PCM_PLUGINS="adpcm alaw asym copy dmix dshare dsnoop empty extplug file hooks iec958 ioplug ladspa lfloat linear meter mmap_emul mulaw multi null plug rate route share shm softvol" APACHE2_MODULES="actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="braindump flow karbon kexi kpresenter krita tables words" CAMERAS="ptp2" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf superstar2 timing tsip tripmate tnt ubx" INPUT_DEVICES="evdev keyboard mouse synaptics" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LINGUAS="en nl fr" PHP_TARGETS="php5-3" RUBY_TARGETS="ruby18" USERLAND="GNU" VIDEO_CARDS="nv nouveau" XFCE_PLUGINS="menu" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account" 
Unset:  CPPFLAGS, CTARGET, EMERGE_DEFAULT_OPTS, INSTALL_MASK, LANG, LC_ALL, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS
Comment 1 Sven Vermeulen 2011-07-21 08:22:37 UTC
Created attachment 280507 [details, diff]
Support transition to portage_fetch_t

This patch introduces a working solution, although it is not as flexible as what is used in fetch.py. If the solution used in fetch.py is not worth it for the binary package support (i.e. support for userfetch and the like) then this could be a solution.
Comment 2 Zac Medico gentoo-dev 2011-07-21 17:06:44 UTC
Created attachment 280541 [details, diff]
support selinux PORTAGE_FETCH_T in BinpkgFetcher

This moves the bulk of the support into SpawnProcess, and uses portage.selinux.spawn_wrapper() to ensure that the exec context it reverted back to normal as soon as possible.
Comment 3 Sven Vermeulen 2011-07-21 17:58:32 UTC
I can also confirm that this patch works
Comment 4 Zac Medico gentoo-dev 2011-07-24 08:57:18 UTC
Thanks for testing. This is fixed in 2.2.0_alpha47, but I'll leave this bug open until it's in an unmasked release.
Comment 5 Zac Medico gentoo-dev 2011-07-29 20:01:25 UTC
This is fixed in 2.1.10.8 and 2.2.0_alpha48.